// Copyright F3 Authors
// SPDX-License-Identifier: MIT

package forgejo

import (
	"context"

	"code.forgejo.org/f3/gof3/v3/f3"
	f3_tree "code.forgejo.org/f3/gof3/v3/tree/f3"
	"code.forgejo.org/f3/gof3/v3/tree/generic"
)

type repositories struct {
	container
}

const RepositoryNameWiki = "vcs.wiki"

func (o *repositories) ListPage(ctx context.Context, node generic.NodeInterface, _ generic.ListOptions, page int) generic.ChildrenList {
	children := generic.NewChildrenList(0)
	if page > 1 {
		return children
	}

	names := []string{f3.RepositoryNameDefault}
	project := f3_tree.GetProject(node).ToFormat().(*f3.Project)
	if project.HasWiki {
		names = append(names, RepositoryNameWiki)
	}

	return f3_tree.ConvertListed(ctx, node, f3_tree.ConvertToAny(names...)...)
}

func newRepositories() generic.NodeDriverInterface {
	return &repositories{}
}
